VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   4215
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   4215
   LinkTopic       =   "Form1"
   ScaleHeight     =   4215
   ScaleWidth      =   4215
   StartUpPosition =   3  'Windows Default
   Begin VB.PictureBox Picture1 
      Height          =   4215
      Left            =   0
      ScaleHeight     =   4155
      ScaleWidth      =   4155
      TabIndex        =   0
      Top             =   0
      Width           =   4215
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Const a As Single = 1
Const b As Single = 0.75
Const c As Single = 1
Const d As Single = 1
Const a2 As Single = a * a
Const b2 As Single = b * b
Const c2 As Single = c * c
Const d2 As Single = d * d

Public Function F(ByVal x As Single, ByVal y As Single) As Single
Dim v As Single

    v = c2 * (d2 - x * x / a2 - y * y / b2)
    If v >= 0 Then
        F = Sqr(v)
    Else
        v = 0
    End If
End Function
'Return the partial derivative of df/dx.
Private Function dFdX(ByVal x As Single, ByVal y As Single) As Single
Dim v As Single

    v = c2 * (d2 - x * x / a2 - y * y / b2)
    If v >= 0 Then
        dFdX = -c2 * x / a2 / Sqr(v)
    Else
        dFdX = 0
    End If
End Function
Private Function dFdY(ByVal x As Single, ByVal y As Single) As Single
Dim v As Single

    v = c2 * (d2 - x * x / a2 - y * y / b2)
    If v >= 0 Then
        dFdY = -c2 * y / b2 / Sqr(v)
    Else
        dFdY = 0
    End If
End Function

' Return F(X, Y).
Private Function xF(ByVal x As Single, ByVal y As Single) As Single
    F = x * x * x * x - 2 * x * x + y * y
End Function
' Return the partial derivative of dF/dX.
Private Function xdFdX(ByVal x As Single, ByVal y As Single) As Single
    dFdX = 4 * x * x * x - 4 * x
End Function
' Return the partial derivative of dF/dY.
Private Function xdFdY(ByVal x As Single, ByVal y As Single) As Single
    dFdY = 2 * y
End Function
' Find a point on the curve close to this one.
Private Sub FindPointOnCurve(ByRef x As Single, ByRef y As Single, ByVal level As Single, Optional ByVal start_x As Single = 0.1, Optional ByVal start_y As Single = 0.2, Optional ByVal tolerance As Single = 0.01, Optional ByVal initial_delta As Single = 0.1)
Dim dZ As Single
Dim dist As Single
Dim delta As Single
Dim F_XY As Single
Dim dx As Single
Dim dy As Single
Dim direction As Integer
Dim check As Long

    ' Start at the starting point.
    x = start_x
    y = start_y
    delta = initial_delta

    ' Repeat until we have a decent solution.
    check = 1
    Do
        ' Make sure we're not running away
        check = check + 1
        If check Mod 100 = 0 Then delta = delta / 2

        ' See how far off we are.
        F_XY = F(x, y)
        dZ = level - F_XY
        If Abs(dZ) < tolerance Then Exit Do

        ' See if we are switching directions.
        If Sgn(dZ) <> direction Then
            ' We are switching directions. Decrease delta.
            delta = delta / 2
            direction = Sgn(dZ)
        End If

        ' Get the gradient.
        Gradient x, y, dx, dy
        If Abs(dx) + Abs(dy) < 0.001 Then Exit Do

        ' Move in the right direction.
        x = x + dx * delta * direction
        y = y + dy * delta * direction
'Debug.Print x; y
    Loop
End Sub
' Return the gradient at this point.
Private Sub Gradient(ByVal x As Single, ByVal y As Single, ByRef dx As Single, ByRef dy As Single)
Dim dist As Single

    dx = dFdX(x, y)
    dy = dFdY(x, y)
    dist = Sqr(dx * dx + dy * dy)
    If Abs(dist) < 0.0001 Then
        dx = 0
        dy = 0
    Else
        dx = dx / dist
        dy = dy / dist
    End If
End Sub
' Plot the level curve F(X, Y) = level.
Private Sub PlotLevelCurve(ByVal pic As PictureBox, ByVal level As Single, ByVal xmin As Single, ByVal xmax As Single, ByVal ymin As Single, ByVal ymax As Single, Optional step_size As Single = 0.1, Optional ByVal start_x As Single = 1#, Optional ByVal start_y As Single = 1#, Optional ByVal tolerance As Single = 0.02)
#Const SHOW_TICS = False

Dim num_points As Integer
Dim X0 As Single
Dim Y0 As Single
Dim x As Single
Dim y As Single
Dim dx As Single
Dim dy As Single

    ' Find a point (X0, Y0) on the level curve.
    FindPointOnCurve X0, Y0, level, start_x, start_y, tolerance

    ' Start here.
    pic.CurrentX = X0
    pic.CurrentY = Y0
    num_points = 1

    ' Start following the level curve.
    x = X0
    y = Y0
    Do
        ' Find the next point along the curve.
        Gradient x, y, dx, dy
        If Abs(dx) + Abs(dy) < 0.001 Then Exit Do
        x = x + dy * step_size
        y = y - dx * step_size
        FindPointOnCurve x, y, level, x, y, tolerance

        ' Draw to this point.
        pic.Line -(x, y)
'Debug.Print x; y
        #If SHOW_TICS Then
            pic.Line -Step(dx * 0.1, dy * 0.1)
            pic.Line -Step(-dx * 0.1, -dy * 0.1)
        #End If
        num_points = num_points + 1

        ' See if the point is outside the drawing area.
        If x < xmin Or x > xmax Or _
           y < ymin Or y > ymax _
                Then Exit Do

        ' If we have gone at least 4 points, see if this
        ' is where we started.
        If num_points >= 4 Then
            If Sqr((X0 - x) * (X0 - x) + (Y0 - y) * (Y0 - y)) <= step_size * 1.1 Then
                pic.Line -(X0, Y0)
                Exit Do
            End If
        End If
    Loop
End Sub
Private Sub Form_Load()
Dim level As Integer

    Show

    Picture1.AutoRedraw = True
    Picture1.ScaleLeft = -1.5
    Picture1.ScaleWidth = 3
    Picture1.ScaleTop = 1.5
    Picture1.ScaleHeight = -3

    For level = 2 To 9
        PlotLevelCurve Picture1, level / 10, _
            -1.5, 1.5, -1.5, 1.5, 0.05, 0.25, 0.25, 0.002
    Next level

    ' Fail to generate curves for 0/10 and 1/10.
    Picture1.ForeColor = vbRed
    For level = 0 To 1
        PlotLevelCurve Picture1, level / 10, _
            -1.5, 1.5, -1.5, 1.5, 0.05, 0.25, 0.25, 0.002
    Next level
End Sub
